unit Spiel_vi;

interface

uses   SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Spin, interakt;

type
                            { 3. Wert zeigt den Spieler: Spieler1 = 1 / Spieler2 = 5 }
TSpielfeld = array[0..3,0..3,0..3]of shortint;

TSpieler = ( Spieler1, Spieler2 );

TSpielertyp = ( Mensch, Computer );

TPosition = record
            Feld:TSpielfeld;
            amZug:TSpieler
            end;

TReihensummenhaeufigkeiten = array[1..20] of byte;

TZug = record
       x,y:integer;
       end;

TSpiel = class
         schwierigkeit: shortint;
         Position:TPosition;
         Spielertyp:array[1..2] of TSpielertyp;

         constructor create(skill: integer;SpTyp1,SpTyp2:TSpielertyp);
{         function Spielerzug:tzug;                                         }
         function Computerzug:tzug;
         procedure ausfuehren (Position:TPosition; Zug:TZug; var neueposition:TPosition);
         function zu_laessig(Position:TPosition; Zug:TZug):boolean;
{         procedure Spielablauf_Starten(PB:TPaintbox);                      }
         function am_Ende(Position:TPosition):boolean;
{         procedure Ausgabe(PB:TPaintbox);                                  }
         function who(s:TSpieler):tspielertyp;
         private
           function Heuristischerwert ( Pos:TPosition ):longint;
           function Reihensummenhaeufigkeiten(Pos:TPosition):TReihensummenhaeufigkeiten;
           function negmax(Position:TPosition;var BesterZug:tzug;maxtiefe:integer):longint;
           function ZvonZug( Pos:TPosition; z:tzug ):byte;
         end;

const e1:longint = 2;
      e2:longint = 30;
      e3:longint = 2000;
      e4:longint = 100000;
      g1:longint = 1;
      g2:longint = 20;
      g3:longint = 1000;
      g4:longint = 50000;


implementation

constructor TSpiel.create(skill: integer;SpTyp1,SpTyp2:TSpielertyp);
var x,y,z,w : byte;
begin
  for z := 0 to 3 do
    for x := 0 to 3 do
      for y := 0 to 3 do position.feld[x,y,z]:=0;

Spielertyp[1]:=SpTyp1;
Spielertyp[2]:=SpTyp2;

schwierigkeit := skill;

end;

function TSpiel.zu_laessig(Position:TPosition; Zug:TZug):boolean;
begin
if Position.Feld[Zug.x,Zug.y,3] = 0
   then zu_laessig := true
   else zu_laessig := false;
end;

function TSpiel.am_Ende( Position:TPosition ):boolean;
var x,y:byte ;
hilfe:treihensummenhaeufigkeiten;
voll:boolean;
begin
hilfe:=Reihensummenhaeufigkeiten(Position);
voll:= true;
for x:= 0 to 3 do
  for y:= 0 to 3 do
    if position.feld[x,y,3] = 0 then voll:= false;

am_ende := (hilfe[4]<> 0) or (hilfe[20]<> 0) or voll ;


end;

function tspiel.who(s:TSpieler):tspielertyp;
  begin
   if s= spieler1
   then who:= spielertyp[1]
   else who:= spielertyp[2];
  end;

(*
function TSpiel.Spielerzug:tzug;
var z:tzug;
s:string;
begin
if position.amzug = spieler1 then s:= 'spieler1' else s:= 'spieler2';
repeat
z.x:= strtoint(inputbox(s,'Bitte geben sie x ein:','0'));
z.y:= strtoint(inputbox(s,'Bitte geben sie y ein:','0'));
if not zu_laessig(Position,Z)
   then ShowMessage('Bitte drehen Sie auf eine gltige Zahl')
until zu_laessig(Position,Z);
Spielerzug:= Z;

end;        *)

function TSpiel.Computerzug:Tzug;
var heurist: longint;
    besterzug: Tzug;
begin

     heurist:= negmax(Position,BesterZug,schwierigkeit);
     Computerzug:= besterzug;
end;

procedure TSpiel.ausfuehren (Position:TPosition; Zug:TZug; var neueposition:TPosition);
var w:byte;z:integer;
begin
neueposition:= position;
if Position.amZug = spieler1
   then begin
          neueposition.amZug:= spieler2;
          w:=5;
        end
   else begin
          neueposition.amZug:= spieler1;
          w:=1;
        end;
z:= zvonzug(position,zug);
neueposition.feld[zug.x,zug.y,z]:=w;

end;

(*
procedure TSpiel.Spielablauf_Starten(PB:TPaintbox);
var Zug:tzug;
    np:TPosition;
begin
   while not am_Ende(Position)
      do begin
         if who(Position.amZug) = Computer
            then Zug:= Computerzug
            else Zug:= Spielerzug;
         ausfuehren(Position,Zug,np);
         position:= np;
         Ausgabe(PB);
         end;
end;


procedure TSpiel.Ausgabe(PB:TPaintbox);
var x,y,z,w : byte;
begin
  for z := 0 to 3 do
    for x := 0 to 3 do
      for y := 0 to 3 do
        begin
          w := Position.Feld[x,y,z];

          if w <> 0 then begin

          if w = 1 then PB.canvas.brush.color:= clred
          else  PB.canvas.brush.color:= cllime;

          PB.canvas.ellipse(x*50+z*5,
                            y*50+z*5,
                            x*50+50-z*5,
                            y*50+50-z*5);
          end;
        end;


end;    *)

function TSpiel.negmax(Position:TPosition;var BesterZug:tzug;maxtiefe:integer):longint;
var x,y:integer;
    Probezug: longint;
    Nachfolgeposition:TPosition;
    aktzug:tzug;
    Wertung:longint;
begin

Wertung:=-1000000;
if (am_Ende(Position)) or (maxtiefe = 0)
   then wertung := heuristischerwert(position)
   else begin
        for x:= 0 to 3 do
          for y:= 0 to 3 do
               begin
                 aktzug.x:= x;
                 aktzug.y:= y;
                 if zu_laessig(Position,aktzug)
                  then begin
                       ausfuehren(Position,aktzug,Nachfolgeposition);
                       Probezug:=negmax(nachfolgeposition,BesterZug,maxtiefe-1);
                  if Probezug >= Wertung
                     then begin
                          Besterzug:=aktzug;
                          Wertung:=Probezug;
                          end;
                        end;
               end;
       end;
negmax:= -Wertung;
end;

function TSpiel.Heuristischerwert ( Pos:TPosition ):longint;
var reihe: Treihensummenhaeufigkeiten;
    h: longint;
begin
reihe:= Reihensummenhaeufigkeiten(Pos);
{        spieler1    spieler2
1            1           0
2            2           0
3            3           0
4            4           0
5            0           1
6            1           1
7            2           1
8            3           1
10           0           2
11           1           2
12           2           2
15           0           3
16           1           3
20           0           4
}

h:= 0;
if pos.amzug = spieler1
   then begin
          h:= h + (reihe[1]*e1);
          h:= h + (reihe[2]*e2);
          h:= h + (reihe[3]*e3);
          h:= h + (reihe[4]*e4);
          h:= h - (reihe[5]*g1);
          h:= h - (reihe[10]*g2);
          h:= h - (reihe[15]*g3);
          h:= h - (reihe[20]*g4);
     end
   else begin
          h:= h - (reihe[1]*g1);
          h:= h - (reihe[2]*g2);
          h:= h - (reihe[3]*g3);
          h:= h - (reihe[4]*g4);
          h:= h + (reihe[5]*e1);
          h:= h + (reihe[10]*e2);
          h:= h + (reihe[15]*e3);
          h:= h + (reihe[20]*e4);
     end;
Heuristischerwert:= h;
end;

function TSpiel.Reihensummenhaeufigkeiten(Pos:TPosition):TReihensummenhaeufigkeiten;
var i,j,k:byte; rsum:TReihensummenhaeufigkeiten; asum:byte; asplr:byte; unint:boolean;
begin
  for i := 0 to 20
    do rsum[i] := 0;   {Vorinitialisierung des Summen-Arrays}

  if pos.amzug = spieler1  {Zge welchen aktuellen Spielers sollen}
    then asplr := 1        {unterscuht werden?}
    else asplr := 5;

  for i:= 0 to 3       {alle Tiefen-Zeilen}
    do for j := 0 to 3
      do begin
           asum := 0;
           unint := false;
           for k := 0 to 3
             do begin
                  if pos.feld[i,j,k] = asplr
                    then inc(asum)
                    else if pos.feld[i,j,k] <> 0
                           then unint := true;
                end;
           if unint then asum := 0;
           inc(rsum[asum]); {Soundsoviel Steine in einer Reihe}
         end;

  for i:= 0 to 3       {alle vertikalen Zeilen}
    do for k := 0 to 3
      do begin
           asum := 0;
           unint := false;
           for j := 0 to 3
             do begin
                  if pos.feld[i,j,k] = asplr
                    then inc(asum)
                    else if pos.feld[i,j,k] <> 0
                           then unint := true;
                end;
           if unint then asum := 0;
           inc(rsum[asum]); {Soundsoviel Steine in einer Reihe}
         end;

  for j:= 0 to 3       {alle horizontalen Zeilen}
    do for k := 0 to 3
      do begin
           asum := 0;
           unint := false;
           for i := 0 to 3
             do begin
                  if pos.feld[i,j,k] = asplr
                    then inc(asum)
                    else if pos.feld[i,j,k] <> 0
                           then unint := true;
                end;
           if unint then asum := 0;
           inc(rsum[asum]); {Soundsoviel Steine in einer Reihe}
         end;

{1a}  for i := 0 to 3
    do begin
         asum := 0;
         unint := false;
         for j := 0 to 3
           do begin
                k := j;
                if pos.feld[j,k,i] = asplr
                  then inc(asum)
                  else if pos.feld[i,j,k] <> 0
                         then unint := true;
              end;
         if unint then asum := 0;
         inc(rsum[asum]);
       end;

 {1b} for i := 0 to 3
    do begin
         asum := 0;
         unint := false;
         for j := 0 to 3
           do begin
                k := j;
                if pos.feld[j,i,k] = asplr
                  then inc(asum)
                  else if pos.feld[j,i,k] <> 0
                         then unint := true;
              end;
         if unint then asum := 0;
         inc(rsum[asum]);
       end;

{1c}  for i := 0 to 3
    do begin
         asum := 0;
         unint := false;
         for j := 0 to 3
           do begin
                k := j;
                if pos.feld[j,k,i] = asplr
                  then inc(asum)
                  else if pos.feld[j,k,i] <> 0
                         then unint := true;
              end;
         if unint then asum := 0;
         inc(rsum[asum]);
       end;

{2a}  for i := 0 to 3
    do begin
         asum := 0;
         unint := false;
         for j := 0 to 3
           do begin
                k := 3-j;
                if pos.feld[j,k,i] = asplr
                  then inc(asum)
                  else if pos.feld[j,k,i] <> 0
                         then unint := true;
              end;
         if unint then asum := 0;
         inc(rsum[asum]);
       end;

{2b}  for i := 0 to 3
    do begin
         asum := 0;
         unint := false;
         for j := 0 to 3
           do begin
                k := 3-j;
                if pos.feld[j,i,k] = asplr
                  then inc(asum)
                  else if pos.feld[j,i,k] <> 0
                         then unint := true;
              end;
         if unint then asum := 0;
         inc(rsum[asum]);
       end;

{2c}  for i := 0 to 3
    do begin
         asum := 0;
         unint := false;
         for j := 0 to 3
           do begin
                k := 3-j;
                if pos.feld[i,j,k] = asplr
                  then inc(asum)
                  else if pos.feld[i,j,k] <> 0
                         then unint := true;
              end;
         if unint then asum := 0;
         inc(rsum[asum]);
       end;

  asum := 0;
  unint:=false;
  for i := 0 to 3
    do begin
         j:=i;
         k:=i;
         if pos.feld[i,j,k] = asplr
           then inc(asum)
           else if pos.feld[i,j,k] <> 0
                  then unint := true;
       end;
         if unint then asum := 0;
         inc(rsum[asum]);

  asum := 0;
  unint:=false;
  for i := 0 to 3
    do begin
         j:=3-i;
         k:=i;
         if pos.feld[i,j,k] = asplr
           then inc(asum)
           else if pos.feld[i,j,k] <> 0
                  then unint := true;
       end;
         if unint then asum := 0;
         inc(rsum[asum]);

  asum := 0;
  unint:=false;
  for i := 0 to 3
    do begin
         j:=i;
         k:=3-i;
         if pos.feld[i,j,k] = asplr
           then inc(asum)
           else if pos.feld[i,j,k] <> 0
                  then unint := true;
       end;
         if unint then asum := 0;
         inc(rsum[asum]);

  asum := 0;
  unint:=false;
  for i := 0 to 3
    do begin
         j:=3-i;
         k:=3-i;
         if pos.feld[i,j,k] = asplr
           then inc(asum)
           else if pos.feld[i,j,k] <> 0
                  then unint := true;
       end;
         if unint then asum := 0;
         inc(rsum[asum]);

  reihensummenhaeufigkeiten := rsum;
end;

function TSpiel.ZvonZug( Pos:TPosition ; z:tzug):byte;
var v:byte;
begin
v:= 0;
while pos.feld[z.x,z.y,v]<> 0 do inc(v);
zvonzug:=v;
end;

end.
