unit U_eing;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, ColorGrd, pmd;

type

TSpielerSetup = record
                 Name: string;
                 color: integer;
                 typ: TSpielertyp;
                end;
TSetup = record
          setup1: TSpielerSetup;
          setup2: TSpielerSetup;
          sg: integer;
         end;

  Tf_ein = class(TForm)
    L_name1: TLabel;
    L_name2: TLabel;
    E_name1: TEdit;
    E_name2: TEdit;
    GB_spieler1: TGroupBox;
    SB_mensch1: TSpeedButton;
    SB_computer1: TSpeedButton;
    GB_spieler2: TGroupBox;
    Sb_mensch2: TSpeedButton;
    SB_computer2: TSpeedButton;
    Gb_farbe1: TGroupBox;
    Sb_rot1: TSpeedButton;
    sb_blau1: TSpeedButton;
    SB_gruen1: TSpeedButton;
    SB_gelb1: TSpeedButton;
    sb_violett1: TSpeedButton;
    gb_farbe2: TGroupBox;
    sb_rot2: TSpeedButton;
    sb_blau2: TSpeedButton;
    sb_gruen2: TSpeedButton;
    Sb_gelb2: TSpeedButton;
    sb_violett2: TSpeedButton;
    img_ok: TImage;
    GB_schwierigkeit: TGroupBox;
    cb_schwierigkeitsgrad: TComboBox;
    procedure img_okClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private


    { Private declarations }
  public

    { Public declarations }
  end;

var
  setup: TSetup;
  f_ein: Tf_ein;

  const
  leicht = 0;
  mittel = 1;
  schwer = 2;

implementation

{$R *.DFM}


procedure Tf_ein.img_okClick(Sender: TObject);
var f: file of TSetup;
begin
     setup.setup1.name:=e_name1.text;
     setup.setup2.name:=e_name2.text;
     if sb_mensch1.down
     then setup.setup1.typ:=Mensch
     else if sb_computer1.down
          then setup.setup1.typ:=Computer ;
     if sb_mensch2.down
     then setup.setup2.typ:=Mensch
     else if sb_computer2.down
          then setup.setup2.typ:=Computer ;
     if sb_rot1.down
     then setup.setup1.color:=0
     else if sb_blau1.down
          then setup.setup1.color:=1
          else if sb_gruen1.down
               then setup.setup1.color:=2
               else if sb_gelb1.down
                    then setup.setup1.color:=3
                    else if sb_violett1.down
                         then setup.setup1.color:=4;
     if sb_rot2.down
     then setup.setup2.color:=0
     else if sb_blau2.down
          then setup.setup2.color:=1
          else if sb_gruen2.down
               then setup.setup2.color:=2
               else if sb_gelb2.down
                    then setup.setup2.color:=3
                    else if sb_violett2.down
                         then setup.setup2.color:=4;
if cb_schwierigkeitsgrad.itemindex = 0 then setup.sg := leicht;
if cb_schwierigkeitsgrad.itemindex = 1 then setup.sg := mittel;
if cb_schwierigkeitsgrad.itemindex = 2 then setup.sg := schwer;

assignfile(f,'3d4g.ini');
FileMode := 1;
rewrite(f);
write(f,setup);
closefile(f);

close;
end;

procedure Tf_ein.FormCreate(Sender: TObject);
var f: file of TSetup;
    ausgelesen: TSetup;
begin
if fileexists('3d4g.ini')
   then begin
        assignfile(f,'3d4g.ini');
        FileMode := 0;
        reset(f);
        read(f,ausgelesen);
        if ausgelesen.setup1.typ = mensch
           then sb_mensch1.down := true
           else sb_computer1.down := true;
        E_name1.text := ausgelesen.setup1.name;
        case ausgelesen.setup1.color of
         0: sb_rot1.down := true;
         1: sb_blau1.down := true;
         2: sb_gruen1.down := true;
         3: sb_gelb1.down := true;
         4: sb_violett1.down := true;
        end;
        if ausgelesen.setup2.typ = mensch
           then sb_mensch2.down := true
           else sb_computer2.down := true;
        E_name2.text := ausgelesen.setup2.name;
        case ausgelesen.setup2.color of
         0: sb_rot2.down := true;
         1: sb_blau2.down := true;
         2: sb_gruen2.down := true;
         3: sb_gelb2.down := true;
         4: sb_violett2.down := true;
        end;
        if ausgelesen.sg = leicht then cb_schwierigkeitsgrad.itemindex := 0;
        if ausgelesen.sg = mittel then cb_schwierigkeitsgrad.itemindex := 1;
        if ausgelesen.sg = schwer then cb_schwierigkeitsgrad.itemindex := 2;
        closefile(f);
        end;

end;

end.
